import type { DirectEventHandler, Int32, Double, Float } from 'react-native/Libraries/Types/CodegenTypes';
import type { ProcessedColorValue, ViewProps, HostComponent } from 'react-native';
import type { UnsafeMixed } from './codegenUtils';
export type OnAnimationFinishEvent = Readonly<{
    isCancelled: boolean;
}>;
export type AnimationFailureEvent = Readonly<{
    error: string;
}>;
export type AnimationLoadedEvent = Readonly<{}>;
type ColorFilterStruct = Readonly<{
    keypath: string;
    color: ProcessedColorValue;
}>;
export interface NativeProps extends ViewProps {
    resizeMode?: string;
    renderMode?: string;
    sourceName?: string;
    sourceJson?: string;
    sourceURL?: string;
    imageAssetsFolder?: string;
    progress?: Float;
    speed?: Double;
    loop?: boolean;
    autoPlay?: boolean;
    enableMergePathsAndroidForKitKatAndAbove?: boolean;
    hardwareAccelerationAndroid?: boolean;
    cacheComposition?: boolean;
    colorFilters?: UnsafeMixed<ReadonlyArray<ColorFilterStruct>>;
    onAnimationFinish?: DirectEventHandler<OnAnimationFinishEvent, 'onAnimationFinish'>;
    onAnimationFailure?: DirectEventHandler<AnimationFailureEvent, 'onAnimationFailure'>;
    onAnimationLoaded?: DirectEventHandler<AnimationLoadedEvent, 'onAnimationLoaded'>;
}
type LottieViewNativeComponentType = HostComponent<NativeProps>;
interface NativeCommands {
    play: (viewRef: React.ElementRef<LottieViewNativeComponentType>, startFrame: Int32, endFrame: Int32) => void;
    reset: (viewRef: React.ElementRef<LottieViewNativeComponentType>) => void;
    pause: (viewRef: React.ElementRef<LottieViewNativeComponentType>) => void;
    resume: (viewRef: React.ElementRef<LottieViewNativeComponentType>) => void;
}
export declare const Commands: NativeCommands;
declare const _default: HostComponent<NativeProps>;
export default _default;
//# sourceMappingURL=LottieAnimationViewNativeComponent.d.ts.map